# Copyright 2017 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  34: "SHORT_EXTERNAL_INTERNALIZED_STRING_TYPE",
  42: "SHORT_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  50: "SHORT_EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  64: "STRING_TYPE",
  65: "CONS_STRING_TYPE",
  66: "EXTERNAL_STRING_TYPE",
  67: "SLICED_STRING_TYPE",
  69: "THIN_STRING_TYPE",
  72: "ONE_BYTE_STRING_TYPE",
  73: "CONS_ONE_BYTE_STRING_TYPE",
  74: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  75: "SLICED_ONE_BYTE_STRING_TYPE",
  77: "THIN_ONE_BYTE_STRING_TYPE",
  82: "EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  98: "SHORT_EXTERNAL_STRING_TYPE",
  106: "SHORT_EXTERNAL_ONE_BYTE_STRING_TYPE",
  114: "SHORT_EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  128: "SYMBOL_TYPE",
  129: "HEAP_NUMBER_TYPE",
  130: "BIGINT_TYPE",
  131: "ODDBALL_TYPE",
  132: "MAP_TYPE",
  133: "CODE_TYPE",
  134: "MUTABLE_HEAP_NUMBER_TYPE",
  135: "FOREIGN_TYPE",
  136: "BYTE_ARRAY_TYPE",
  137: "BYTECODE_ARRAY_TYPE",
  138: "FREE_SPACE_TYPE",
  139: "FIXED_INT8_ARRAY_TYPE",
  140: "FIXED_UINT8_ARRAY_TYPE",
  141: "FIXED_INT16_ARRAY_TYPE",
  142: "FIXED_UINT16_ARRAY_TYPE",
  143: "FIXED_INT32_ARRAY_TYPE",
  144: "FIXED_UINT32_ARRAY_TYPE",
  145: "FIXED_FLOAT32_ARRAY_TYPE",
  146: "FIXED_FLOAT64_ARRAY_TYPE",
  147: "FIXED_UINT8_CLAMPED_ARRAY_TYPE",
  148: "FIXED_BIGINT64_ARRAY_TYPE",
  149: "FIXED_BIGUINT64_ARRAY_TYPE",
  150: "FIXED_DOUBLE_ARRAY_TYPE",
  151: "FILLER_TYPE",
  152: "ACCESS_CHECK_INFO_TYPE",
  153: "ACCESSOR_INFO_TYPE",
  154: "ACCESSOR_PAIR_TYPE",
  155: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  156: "ALLOCATION_MEMENTO_TYPE",
  157: "ALLOCATION_SITE_TYPE",
  158: "ASYNC_GENERATOR_REQUEST_TYPE",
  159: "CONTEXT_EXTENSION_TYPE",
  160: "DEBUG_INFO_TYPE",
  161: "FUNCTION_TEMPLATE_INFO_TYPE",
  162: "INTERCEPTOR_INFO_TYPE",
  163: "MODULE_INFO_ENTRY_TYPE",
  164: "MODULE_TYPE",
  165: "OBJECT_TEMPLATE_INFO_TYPE",
  166: "PROMISE_CAPABILITY_TYPE",
  167: "PROMISE_REACTION_TYPE",
  168: "PROTOTYPE_INFO_TYPE",
  169: "SCRIPT_TYPE",
  170: "STACK_FRAME_INFO_TYPE",
  171: "TUPLE2_TYPE",
  172: "TUPLE3_TYPE",
  173: "WASM_COMPILED_MODULE_TYPE",
  174: "WASM_DEBUG_INFO_TYPE",
  175: "WASM_SHARED_MODULE_DATA_TYPE",
  176: "CALLABLE_TASK_TYPE",
  177: "CALLBACK_TASK_TYPE",
  178: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  179: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  180: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  181: "FIXED_ARRAY_TYPE",
  182: "BOILERPLATE_DESCRIPTION_TYPE",
  183: "DESCRIPTOR_ARRAY_TYPE",
  184: "HASH_TABLE_TYPE",
  185: "SCOPE_INFO_TYPE",
  186: "TRANSITION_ARRAY_TYPE",
  187: "CELL_TYPE",
  188: "CODE_DATA_CONTAINER_TYPE",
  189: "FEEDBACK_CELL_TYPE",
  190: "FEEDBACK_VECTOR_TYPE",
  191: "LOAD_HANDLER_TYPE",
  192: "PROPERTY_ARRAY_TYPE",
  193: "PROPERTY_CELL_TYPE",
  194: "SHARED_FUNCTION_INFO_TYPE",
  195: "SMALL_ORDERED_HASH_MAP_TYPE",
  196: "SMALL_ORDERED_HASH_SET_TYPE",
  197: "STORE_HANDLER_TYPE",
  198: "WEAK_CELL_TYPE",
  1024: "JS_PROXY_TYPE",
  1025: "JS_GLOBAL_OBJECT_TYPE",
  1026: "JS_GLOBAL_PROXY_TYPE",
  1027: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_VALUE_TYPE",
  1056: "JS_API_OBJECT_TYPE",
  1057: "JS_OBJECT_TYPE",
  1058: "JS_ARGUMENTS_TYPE",
  1059: "JS_ARRAY_BUFFER_TYPE",
  1060: "JS_ARRAY_ITERATOR_TYPE",
  1061: "JS_ARRAY_TYPE",
  1062: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  1063: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  1064: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  1065: "JS_DATE_TYPE",
  1066: "JS_ERROR_TYPE",
  1067: "JS_GENERATOR_OBJECT_TYPE",
  1068: "JS_MAP_TYPE",
  1069: "JS_MAP_KEY_ITERATOR_TYPE",
  1070: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  1071: "JS_MAP_VALUE_ITERATOR_TYPE",
  1072: "JS_MESSAGE_OBJECT_TYPE",
  1073: "JS_PROMISE_TYPE",
  1074: "JS_REGEXP_TYPE",
  1075: "JS_SET_TYPE",
  1076: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  1077: "JS_SET_VALUE_ITERATOR_TYPE",
  1078: "JS_STRING_ITERATOR_TYPE",
  1079: "JS_WEAK_MAP_TYPE",
  1080: "JS_WEAK_SET_TYPE",
  1081: "JS_TYPED_ARRAY_TYPE",
  1082: "JS_DATA_VIEW_TYPE",
  1083: "WASM_INSTANCE_TYPE",
  1084: "WASM_MEMORY_TYPE",
  1085: "WASM_MODULE_TYPE",
  1086: "WASM_TABLE_TYPE",
  1087: "JS_BOUND_FUNCTION_TYPE",
  1088: "JS_FUNCTION_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  0x02201: (138, "FreeSpaceMap"),
  0x02259: (132, "MetaMap"),
  0x022b1: (131, "NullMap"),
  0x02309: (183, "DescriptorArrayMap"),
  0x02361: (181, "FixedArrayMap"),
  0x023b9: (151, "OnePointerFillerMap"),
  0x02411: (151, "TwoPointerFillerMap"),
  0x02469: (131, "UninitializedMap"),
  0x024c1: (8, "OneByteInternalizedStringMap"),
  0x02519: (131, "UndefinedMap"),
  0x02571: (129, "HeapNumberMap"),
  0x025c9: (131, "TheHoleMap"),
  0x02621: (131, "BooleanMap"),
  0x02679: (136, "ByteArrayMap"),
  0x026d1: (181, "FixedCOWArrayMap"),
  0x02729: (184, "HashTableMap"),
  0x02781: (128, "SymbolMap"),
  0x027d9: (72, "OneByteStringMap"),
  0x02831: (185, "ScopeInfoMap"),
  0x02889: (194, "SharedFunctionInfoMap"),
  0x028e1: (133, "CodeMap"),
  0x02939: (181, "FunctionContextMap"),
  0x02991: (187, "CellMap"),
  0x029e9: (198, "WeakCellMap"),
  0x02a41: (193, "GlobalPropertyCellMap"),
  0x02a99: (135, "ForeignMap"),
  0x02af1: (186, "TransitionArrayMap"),
  0x02b49: (190, "FeedbackVectorMap"),
  0x02ba1: (131, "ArgumentsMarkerMap"),
  0x02bf9: (131, "ExceptionMap"),
  0x02c51: (131, "TerminationExceptionMap"),
  0x02ca9: (131, "OptimizedOutMap"),
  0x02d01: (131, "StaleRegisterMap"),
  0x02d59: (181, "NativeContextMap"),
  0x02db1: (181, "ModuleContextMap"),
  0x02e09: (181, "EvalContextMap"),
  0x02e61: (181, "ScriptContextMap"),
  0x02eb9: (181, "BlockContextMap"),
  0x02f11: (181, "CatchContextMap"),
  0x02f69: (181, "WithContextMap"),
  0x02fc1: (181, "DebugEvaluateContextMap"),
  0x03019: (181, "ScriptContextTableMap"),
  0x03071: (181, "ArrayListMap"),
  0x030c9: (130, "BigIntMap"),
  0x03121: (182, "BoilerplateDescriptionMap"),
  0x03179: (137, "BytecodeArrayMap"),
  0x031d1: (188, "CodeDataContainerMap"),
  0x03229: (1057, "ExternalMap"),
  0x03281: (150, "FixedDoubleArrayMap"),
  0x032d9: (184, "GlobalDictionaryMap"),
  0x03331: (189, "ManyClosuresCellMap"),
  0x03389: (1072, "JSMessageObjectMap"),
  0x033e1: (181, "ModuleInfoMap"),
  0x03439: (134, "MutableHeapNumberMap"),
  0x03491: (184, "NameDictionaryMap"),
  0x034e9: (189, "NoClosuresCellMap"),
  0x03541: (184, "NumberDictionaryMap"),
  0x03599: (189, "OneClosureCellMap"),
  0x035f1: (184, "OrderedHashMapMap"),
  0x03649: (184, "OrderedHashSetMap"),
  0x036a1: (192, "PropertyArrayMap"),
  0x036f9: (184, "SimpleNumberDictionaryMap"),
  0x03751: (181, "SloppyArgumentsElementsMap"),
  0x037a9: (195, "SmallOrderedHashMapMap"),
  0x03801: (196, "SmallOrderedHashSetMap"),
  0x03859: (184, "StringTableMap"),
  0x038b1: (184, "WeakHashTableMap"),
  0x03909: (106, "NativeSourceStringMap"),
  0x03961: (64, "StringMap"),
  0x039b9: (73, "ConsOneByteStringMap"),
  0x03a11: (65, "ConsStringMap"),
  0x03a69: (77, "ThinOneByteStringMap"),
  0x03ac1: (69, "ThinStringMap"),
  0x03b19: (67, "SlicedStringMap"),
  0x03b71: (75, "SlicedOneByteStringMap"),
  0x03bc9: (66, "ExternalStringMap"),
  0x03c21: (82, "ExternalStringWithOneByteDataMap"),
  0x03c79: (74, "ExternalOneByteStringMap"),
  0x03cd1: (98, "ShortExternalStringMap"),
  0x03d29: (114, "ShortExternalStringWithOneByteDataMap"),
  0x03d81: (0, "InternalizedStringMap"),
  0x03dd9: (2, "ExternalInternalizedStringMap"),
  0x03e31: (18, "ExternalInternalizedStringWithOneByteDataMap"),
  0x03e89: (10, "ExternalOneByteInternalizedStringMap"),
  0x03ee1: (34, "ShortExternalInternalizedStringMap"),
  0x03f39: (50, "ShortExternalInternalizedStringWithOneByteDataMap"),
  0x03f91: (42, "ShortExternalOneByteInternalizedStringMap"),
  0x03fe9: (106, "ShortExternalOneByteStringMap"),
  0x04041: (140, "FixedUint8ArrayMap"),
  0x04099: (139, "FixedInt8ArrayMap"),
  0x040f1: (142, "FixedUint16ArrayMap"),
  0x04149: (141, "FixedInt16ArrayMap"),
  0x041a1: (144, "FixedUint32ArrayMap"),
  0x041f9: (143, "FixedInt32ArrayMap"),
  0x04251: (145, "FixedFloat32ArrayMap"),
  0x042a9: (146, "FixedFloat64ArrayMap"),
  0x04301: (147, "FixedUint8ClampedArrayMap"),
  0x04359: (149, "FixedBigUint64ArrayMap"),
  0x043b1: (148, "FixedBigInt64ArrayMap"),
  0x04409: (171, "Tuple2Map"),
  0x04461: (169, "ScriptMap"),
  0x044b9: (162, "InterceptorInfoMap"),
  0x04511: (153, "AccessorInfoMap"),
  0x04569: (152, "AccessCheckInfoMap"),
  0x045c1: (154, "AccessorPairMap"),
  0x04619: (155, "AliasedArgumentsEntryMap"),
  0x04671: (156, "AllocationMementoMap"),
  0x046c9: (157, "AllocationSiteMap"),
  0x04721: (158, "AsyncGeneratorRequestMap"),
  0x04779: (159, "ContextExtensionMap"),
  0x047d1: (160, "DebugInfoMap"),
  0x04829: (161, "FunctionTemplateInfoMap"),
  0x04881: (163, "ModuleInfoEntryMap"),
  0x048d9: (164, "ModuleMap"),
  0x04931: (165, "ObjectTemplateInfoMap"),
  0x04989: (166, "PromiseCapabilityMap"),
  0x049e1: (167, "PromiseReactionMap"),
  0x04a39: (168, "PrototypeInfoMap"),
  0x04a91: (170, "StackFrameInfoMap"),
  0x04ae9: (172, "Tuple3Map"),
  0x04b41: (173, "WasmCompiledModuleMap"),
  0x04b99: (174, "WasmDebugInfoMap"),
  0x04bf1: (175, "WasmSharedModuleDataMap"),
  0x04c49: (176, "CallableTaskMap"),
  0x04ca1: (177, "CallbackTaskMap"),
  0x04cf9: (178, "PromiseFulfillReactionJobTaskMap"),
  0x04d51: (179, "PromiseRejectReactionJobTaskMap"),
  0x04da9: (180, "PromiseResolveThenableJobTaskMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("OLD_SPACE", 0x02201): "NullValue",
  ("OLD_SPACE", 0x02231): "EmptyDescriptorArray",
  ("OLD_SPACE", 0x02251): "EmptyFixedArray",
  ("OLD_SPACE", 0x02261): "UninitializedValue",
  ("OLD_SPACE", 0x022e1): "UndefinedValue",
  ("OLD_SPACE", 0x02311): "NanValue",
  ("OLD_SPACE", 0x02321): "TheHoleValue",
  ("OLD_SPACE", 0x02371): "HoleNanValue",
  ("OLD_SPACE", 0x02381): "TrueValue",
  ("OLD_SPACE", 0x023f1): "FalseValue",
  ("OLD_SPACE", 0x02441): "empty_string",
  ("OLD_SPACE", 0x02459): "EmptyScopeInfo",
  ("OLD_SPACE", 0x02469): "ArgumentsMarker",
  ("OLD_SPACE", 0x024c1): "Exception",
  ("OLD_SPACE", 0x02519): "TerminationException",
  ("OLD_SPACE", 0x02579): "OptimizedOut",
  ("OLD_SPACE", 0x025d1): "StaleRegister",
  ("OLD_SPACE", 0x02661): "EmptyByteArray",
  ("OLD_SPACE", 0x02681): "EmptyFixedUint8Array",
  ("OLD_SPACE", 0x026a1): "EmptyFixedInt8Array",
  ("OLD_SPACE", 0x026c1): "EmptyFixedUint16Array",
  ("OLD_SPACE", 0x026e1): "EmptyFixedInt16Array",
  ("OLD_SPACE", 0x02701): "EmptyFixedUint32Array",
  ("OLD_SPACE", 0x02721): "EmptyFixedInt32Array",
  ("OLD_SPACE", 0x02741): "EmptyFixedFloat32Array",
  ("OLD_SPACE", 0x02761): "EmptyFixedFloat64Array",
  ("OLD_SPACE", 0x02781): "EmptyFixedUint8ClampedArray",
  ("OLD_SPACE", 0x027e1): "EmptyScript",
  ("OLD_SPACE", 0x02869): "ManyClosuresCell",
  ("OLD_SPACE", 0x02879): "EmptySloppyArgumentsElements",
  ("OLD_SPACE", 0x02899): "EmptySlowElementDictionary",
  ("OLD_SPACE", 0x028e1): "EmptyOrderedHashMap",
  ("OLD_SPACE", 0x02909): "EmptyOrderedHashSet",
  ("OLD_SPACE", 0x02931): "EmptyPropertyCell",
  ("OLD_SPACE", 0x02959): "EmptyWeakCell",
  ("OLD_SPACE", 0x029c9): "NoElementsProtector",
  ("OLD_SPACE", 0x029f1): "IsConcatSpreadableProtector",
  ("OLD_SPACE", 0x02a01): "SpeciesProtector",
  ("OLD_SPACE", 0x02a29): "StringLengthProtector",
  ("OLD_SPACE", 0x02a39): "ArrayIteratorProtector",
  ("OLD_SPACE", 0x02a61): "ArrayBufferNeuteringProtector",
  ("OLD_SPACE", 0x02ae9): "InfinityValue",
  ("OLD_SPACE", 0x02af9): "MinusZeroValue",
  ("OLD_SPACE", 0x02b09): "MinusInfinityValue",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "OPTIMIZED",
  "WASM_COMPILED",
  "WASM_TO_JS",
  "WASM_TO_WASM",
  "JS_TO_WASM",
  "WASM_INTERPRETER_ENTRY",
  "C_WASM_ENTRY",
  "INTERPRETED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "INTERNAL",
  "CONSTRUCT",
  "ARGUMENTS_ADAPTOR",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
